//
//  ish file converter (ish.dll) for Microsoft Windows
//
//---------------------------------------------------------------
//	   (C) Pekin
//	  Public Domain Software
//
//  1987.11.11	  	ken Miyazaki(ken)
//  1987.11.28		O Imaizumi(Gigo)
//  1987.12.05 		Bug Fix
//  1987.12.06 		OS9Ext support.
//  1988.01.31 		V.1.11
//  1988.02.06 		for Human68K(Gigo)
//  1988.05.10 		for UNIX (kondo)
//  1990.07.12 		non-kana (keizo)
//  1994.			for Microsoft Windows (nonki)
//  1995.01			for Visual C and Error Code (asato)
//  1995.02			/Y option (asato)
//  1995.03.26		Fix Default Dir Bug (asato)
//  1995.06.06      Fix Wildcard matching Bug(asato)
//
//  special thanks for M.ishizuka(ish)
//---------------------------------------------------------------
//

#ifndef ISH_DLL_H       
#define ISH_DLL_H

#ifndef EXPORT
 #ifdef WIN32
  #define EXPORT 
 #else
  #define EXPORT _export
 #endif
#endif // EXPORT

#ifdef __cplusplus
extern "C" {
#endif  // __cplusplus
//---------------------------------------------------------------

#define ISH_VERSION             36

/* WARNING */
#define ERROR_DISK_SPACE		0x8005		// Disk̋󂫂܂(𓀎)
#define ERROR_READ_ONLY			0x8006		// 𓀐̃t@C[hI[(ReplacełȂ)
#define ERROR_USER_SKIP			0x8007		// [U[ɂĉ𓀂XLbv܂
#define ERROR_UNKOWN_TYPE		0x8008
#define ERROR_METHOD			0x8009
#define ERROR_PASSWORD_FILE		0x800A
#define ERROR_VERSION			0x800B
#define ERROR_FILE_CRC			0x800C		// G[s
#define ERROR_FILE_OPEN			0x800D		// 𓀎Ƀt@CI[vłȂ
#define ERROR_MORE_FRESH		0x800E
#define ERROR_NOT_EXIST			0x800F
#define ERROR_ALREADY_EXIST		0x8010

#define ERROR_TOO_MANY_FILES	0x8011

/* ERROR */
#ifndef ERROR_DIRECTORY
 #define ERROR_DIRECTORY		0x8012
#endif
#define ERROR_CANNOT_WRITE		0x8013
#define ERROR_HUFFMAN_CODE		0x8014
#define ERROR_COMMENT_HEADER	0x8015
#define ERROR_HEADER_CRC		0x8016
#define ERROR_HEADER_BROKEN		0x8017
#define ERROR_ARCHIVE_FILE_OPEN	0x8018		// HeaderȂ
#define ERROR_NOT_ARCHIVE_FILE	0x8019
#define ERROR_CANNOT_READ		0x801A
#define ERROR_FILE_STYLE		0x801B
#define ERROR_COMMAND_NAME		0x801C
#define ERROR_MORE_HEAP_MEMORY	0x801D
#define ERROR_ENOUGH_MEMORY		0x801E
#define ERROR_ALREADY_RUNNING	0x801F
#define ERROR_USER_CANCEL		0x8020

#define ERROR_NOT_SUPPORT		0x8023

#define	ERROR_CANNOT_CREATE		0x8030		// ISHt@C쐬ł܂		
#define	ERROR_CANNOT_OPEN		0x8031		// t@CI[vłȂ(쐬)

// --------------------------------------------------------------
// Ish : Ish̏s܂B
//                   
//		hwnd        : EChEnh
//		lpszCmdLine : R}hC
//                    (restoreł΃t@Ĉ݁A
//                     storeł"/s t@C"łł܂Bj
//
//         E^쐬 ʂ̃IvV
//				/f=<dirname> : 𓀐fBNgw肵܂
//
//         ẼIvV
//				/r : restore new file(s)
//				/a : restore all file(s)
//				/q : restore with question
//
//         E쐬̃IvV
//
//           E쐬[h
//				/s : store a JIS8 format ish file
//		       	/s8: same as -s
//				/ss: store a shift JIS format ish file  
//				/s7: store a JIS7 format ish file
//				/sn: store a shift JIS non-kana format ish file
//
//           EΏOS
//				/m : MS-DOS
//				/u : UNIX
//				/c : CP/M
//				/9 : OS-9
//				/? : other OS(s)
//				/* : all OS(s)
//
//           EGXP[vV[PX̎gp
//				/n : no ESC sequence in TITLE line      
//				/e : ESC sequence in TITLE line
//
//           E^Cgލs
//				/tn: title in n line
//
//			 EDecodet@Cw(wt@ĈDecode)
//				/Y <filename>
//				w̏ꍇ́A/Y <filename> /Y <filename> ...
//				ChJ[hw(?, *)
//
//			 Eǉo(쐬̂ݗL)
//				/YA <filename>
//				w̃t@Cɒǉo͂
//				Aɓt@Cꍇɒ
//
// -------------------------------------------------------------
//int WINAPI EXPORT Ish(HWND hwnd, LPSTR lpszCmdLine, LPSTR lpszDir);
int WINAPI EXPORT Ish(HWND hwnd, LPSTR lpszCmdLine);

// --------------------------------------------------------------
// IshGetVersion : ish.dll̃o[WԂ܂B
//                   
//    ʂintŖ߂܂BႦ
//	    001Ver0.01
//      100Ver1.00
//    ƂȂ܂B
// --------------------------------------------------------------
int WINAPI EXPORT IshGetVersion(void);

// --------------------------------------------------------------
// IshGetRunning : ish.dll쒆Ԃ܂B
//                   
//    TRUEł΁A쒆Ȃ̂Ŏgpł܂B
//	  FALSEł΁Agpł܂B
// --------------------------------------------------------------
BOOL WINAPI EXPORT IshGetRunning(void);

// --------------------------------------------------------------
// IshConfigDialog : ish.dll̊ݒ_CAO\܂B
//                   ߂lpszOptɃR}hČ`
//                   Ԃ܂B
//
//	hwnd 	: EChEnh
//	lpszOpt : _CAOŐݒ肵R}hCi[܂B
//            lpszOpt́AK128oCgȏ̑傫pӂĂB
//            ܂AĂяoɃp[^ݒ肷΃_CAȌ
//            l̃p[^ɂȂ܂B
//            ""n΁Aarchive.iniɐݒ肳ꂽp[^l
//            Ȃ܂B
//  mode    : i𓀁jñR}hCݒ肷ꍇ
//            UNPACK_CONFIG_MODEA쐬ikjñR}hC
//            ݒ肷ꍇPACK_CONFIG_MODEݒ肵ĂB
//  ߂l  : ݒsꍇTRUEALZꍇFALSE
//            ߂܂B
//
// --------------------------------------------------------------
#define UNPACK_CONFIG_MODE	1
#define PACK_CONFIG_MODE	2

BOOL WINAPI EXPORT IshConfigDialog(HWND hwnd, LPSTR lpszOpt, int mode);

// --------------------------------------------------------------
// IshCheckArchive : lpszFileNameŎw肵t@Cishf[^
//                   ܂܂Ă邩𒲂ׂ܂B
//                   A݂̎dlł̓t@C݂TRUE
//					 ԂĂ܂B
// --------------------------------------------------------------
BOOL WINAPI EXPORT IshCheckArchive(LPSTR lpszFileName, int iMode);

// --------------------------------------------------------------
// ȉ̊֐͖łALHA.DLL̃A[JCuDLLƂ
// ݊̂߂ɃGgpӂĂ܂B
BOOL WINAPI EXPORT IshGetBackGroundMode(void);
BOOL WINAPI EXPORT IshSetBackGroundMode(BOOL bBackGroundMode);
BOOL WINAPI EXPORT IshGetCursorMode(void);
BOOL WINAPI EXPORT IshSetCursorMode(BOOL bCursorMode);
unsigned int WINAPI EXPORT IshGetCursorInterval(void);
BOOL WINAPI EXPORT IshSetCursorInterval(unsigned int uInterval);

// --------------------------------------------------------------
// IshEx : Ish̏s܂B
//                   
//  LHA.DLL݊̃C^[tFCXłB
//	R}hC̎ẃAIsh()ƓłB
//  sʂAszOutputɕԂ܂B
//                   
//	lpszCmdLine : R}hC
//                    (restoreł΃t@Ĉ݁A
//                     storeł"/s t@C"łł܂Bj
//  lpszOutput   : ʂԂobt@w肵܂B
//  wSize        : obt@̃TCYw肵܂BԂʂ̃TCY菬ꍇ
//                 wTCY܂ŕԂB
//  ߂l       : Ȉꍇ0AG[̂Ƃ̓G[R[h
// -------------------------------------------------------------
int WINAPI EXPORT IshEx(LPSTR lpszCmdLine, LPSTR lpszOutput, WORD wSize);


// --------------------------------------------------------------
// IshListFile : lpszFileNameŎw肵t@Cishf[^t@C
//               ꗗszOutputŎw肳ꂽ̈Ɏ̌`ŕԂ܂B
//               (1:,2:͊܂܂܂Bes̖LF(0Ah)ƂȂ܂B)
// 1:
// 2:Listing of Ish : <file>
// 3:
// 4:
// 5:  Name            Size      Date     Time    Type  Vol
// 6:
// 7:--------------  --------  -------- -------- ------ ---
// 8:
// 9:<file1>
//10:                 1571168  94-12-05 17:19:36 MS-DOS 
//11:<file2>
//12:                 1571168  94-12-05 17:19:36 OTHER  
//  :
//  :......................................................
//  :
// n:--------------  --------  -------- -------- ------ ---
//
//	lpszFileName : ISHf[^܂ރt@Cw肵܂B
//  lpszOutput   : ʂԂobt@w肵܂B
//  wSize        : obt@̃TCYw肵܂BԂʂ̃TCY菬ꍇ
//                 wTCY܂ŕԂB
//  ߂l       : Ȉꍇ0AG[̂Ƃ̓G[R[h
//                 ISHf[^܂܂Ȃꍇ́AERROR_NOT_ARCHIVE_FILEԂB
//  ̑       : G[bZ[W͏o͂Ȃ
//---------------------------------------------------------------
int WINAPI EXPORT IshFileList(LPSTR lpszFileName, LPSTR lpszOutput, WORD wSize);

#ifdef __cplusplus
}                       /* End of extern "C" { */
#endif  // __cplusplus

#endif	// ISH_DLL_H
